;============= BioChart  V1.2  [ Script For mIRC ]   ==========================
;-------------------------- by KiloVolt,  1998 -------------------------------

on 1:load:{
  echo $colour(kick) -s ------ Este script agrega la opcion 'BioRitmo' al menu de status.
  echo $colour(kick) -s ------ Pon la fecha de tu nacimiento o la fecha de la que quieres averigurar el bioritmo.
  echo $colour(kick) -s ------ Seleciona 'Dibujar' y se dibujara el grafico del bioritmo.
}

menu status {
  -
  BioRitmo
  .Poner fecha de nacimiento: BioGetBirth
  .Dibujar Bioritmo: Biorythm
}  

alias BioGetBirth {
  set %Bio.BirthD $$?="Pon tu fecha de nacimiento en formato mm/dd/yyyy"
  if ( $count(%Bio.BirthD,$chr(47)) != 2) { zecho $colour(kick) Formato de fecha erroneo, comprueba el numero de barras. | unset %Bio.* BP.* | halt }
  elseif ( $gettok(%Bio.BirthD,3,47) >= $gettok($fulldate,5,32)) { zecho $colour(kick) El ao de nacimiento debe ser anterior a este ao! | unset %Bio.* BP.* | halt }
  elseif ( $len( $gettok(%Bio.BirthD,1,47)) > 2) { zecho $colour(kick) Has puesto un formato para el mes incorrecto. Usa 1 o 2 cifras (5, 05, 11, etc.). | unset %Bio.* BP.* | halt }
  elseif ( $len( $gettok(%Bio.BirthD,2,47)) > 2) { zecho $colour(kick) Has puesto un formato para el dia incorrecto. Usa 1 o 2 cifras (5, 05, 15, etc). | unset %Bio.* BP.* | halt }
  elseif ( $len( $gettok(%Bio.BirthD,3,47)) < 4) { zecho $colour(kick) Has puesto un formato para el ao incorrecto. Usa 4 cifras (1975, 1980, etc). | unset %Bio.* BP.* | halt }
  set %BioBirthDStr $calc($gettok(%Bio.BirthD,1,47) + 0) $+ $chr(32) $+ $calc($gettok(%Bio.BirthD,2,47) + 0) $+ $chr(32) $+ $gettok(%Bio.BirthD,3,47)
  if ( $BioDatValid(%BioBirthDStr) == 0) { zecho $colour(kick) Has puesto una fecha no valida, repasala a ver | unset %Bio.* BP.* %BioBirthDStr | halt }
  zecho $colour(kick) La fecha de nacimiento ha sido puesta como: %Bio.BirthD
}

alias Biodat2Julian {
  unset %Bio.dat2J.*
  %Bio.dat2J.d1 = $calc( $1 - 14 )
  %Bio.dat2J.d2 = $int( $calc( %Bio.dat2J.d1 / 12 ))
  %Bio.dat2J.d3 = $int( $calc( %Bio.dat2J.d2 * 12 ))
  %Bio.dat2J.ky = $calc( $3 + 4800 + %Bio.dat2J.d2 )
  %Bio.dat2J.km = $calc( $1 - 2 - %Bio.dat2J.d3 )
  %Bio.dat2J.j1 = $int( $calc((1461 * %Bio.dat2J.ky ) / 4))
  %Bio.dat2J.j2 = $int( $calc(( 367 * %Bio.dat2J.km ) / 12))
  %Bio.dat2J.j3 = $int( $calc( %Bio.dat2J.ky + 100 ))
  %Bio.dat2J.j4 = $int( $calc( %Bio.dat2J.j3 / 100 ))
  %Bio.dat2J.j5 = $int( $calc( 3 * %Bio.dat2J.j4 / 4 ))
  %Bio.dat2J.jd = $int( $calc( $2 - 32075 + %Bio.dat2J.j1 + %Bio.dat2J.j2 - %Bio.dat2J.j5 ))
  return %Bio.dat2J.jd
}

alias BioJulian2dat {
  unset %Bio.J2dat.*
  %Bio.J2dat.v1 = $calc( $1 + 68569)
  %Bio.J2dat.v2 = $int( $calc(4 * %Bio.J2dat.v1 / 146097))
  %Bio.J2dat.v3 = $int( $calc(((146097 * %Bio.J2dat.v2) + 3) / 4))
  %Bio.J2dat.ld = $calc( %Bio.J2dat.v1 - %Bio.J2dat.v3)
  %Bio.J2dat.ly = $int( $calc(4000 * (%Bio.J2dat.ld + 1) / 1461001))
  %Bio.J2dat.v4 = $int( $calc((1461 * %Bio.J2dat.ly) / 4))
  %Bio.J2dat.kd = $calc( %Bio.J2dat.ld - %Bio.J2dat.v4 + 31)
  %Bio.J2dat.km = $int( $calc((80 * %Bio.J2dat.kd) / 2447))
  %Bio.J2dat.id = $calc( %Bio.J2dat.kd - $int($calc(( 2447 * %Bio.J2dat.km) / 80)))
  %Bio.J2dat.im = $calc( %Bio.J2dat.km + 2 - 12 * $int( $calc(%Bio.J2dat.km / 11)))
  %Bio.J2dat.iy = $calc(( 100 * (%Bio.J2dat.v2 - 49)) + %Bio.J2dat.ly + $int( $calc( %Bio.J2dat.km / 11)))
  return %Bio.J2dat.im %Bio.J2dat.id %Bio.J2dat.iy
}

alias BioDatValid {
  set %Bio.DatValid.dat $1-
  set %Bio.DatValid.temp1 $Biodat2Julian(%Bio.DatValid.dat)
  set %Bio.DatValid.temp2 $Biojulian2dat(%Bio.DatValid.temp1)
  if ( %Bio.DatValid.temp2 == %Bio.DatValid.dat ) { return 1 }
  else { return 0 }
}

alias BioDayofWk {
  %Bio.daywk = $int($calc((($1 + 1) % 7) + 1))
  if %Bio.daywk == 1 return Do
  elseif %Bio.daywk == 2 return L
  elseif %Bio.daywk == 3 return M
  elseif %Bio.daywk == 4 return X
  elseif %Bio.daywk == 5 return J
  elseif %Bio.daywk == 6 return V
  elseif %Bio.daywk == 7 return Sa
}

alias BioRythm {
  if (%BioBirthDStr == $null) { zecho $colour(kick) Debes especificar tu fecha de nacimiento antes de hacer el dibujo | unset %Bio.* BP.* | halt }
  set %Bio.BirthJ $Biodat2Julian(%BioBirthDStr)
  set %Bio.datStr  $gettok($date,2,47) $+ $chr(32) $+ $gettok($date,1,47) $+ $chr(32) $+ $gettok($fulldate,5,32)
  %Bio.TodayJ = $Biodat2Julian( %Bio.datStr )
  %Bio.DaysLived  =  $calc(%Bio.TodayJ - %Bio.BirthJ)
  %Bio.PhyFraction = $calc(%Bio.DaysLived % 23)
  %Bio.EmoFraction = $calc(%Bio.DaysLived % 28)
  %Bio.IntFraction = $calc(%Bio.DaysLived % 33)
  BioPlot
}

alias BioPlot {
  set %BP.VertOffset 150 | set %BP.HorzOffset 20
  set %BP.VertScale 100 | set %BP.HorzScale 18
  set %BP.HorzMax $calc((%BP.HorzScale * 30) + %BP.HorzOffset + 20))
  window -c @BioRitmo
  window -pk @BioRitmo 50 50  $int($calc(%BP.HorzMax + 50)) $int($calc((%BP.VertScale * 2) + %BP.VertOffset))
  drawrect -f  @BioRitmo 2 1 2 2 $int($calc(%BP.HorzMax + 45)) $int($calc((%BP.VertScale * 2) + %BP.VertOffset - 5))
  titlebar @BioRitmo Dibujo para la fecha de nacimiento %BioBirthDStr
  drawline @BioRitmo 14 3 $calc(%BP.HorzOffset - 10) %BP.VertOffset %BP.HorzMax %BP.VertOffset
  drawline @BioRitmo 14 3 %BP.HorzOffset $calc(%BP.VertOffset - %BP.VertScale - 20)  %BP.HorzOffset $calc(%BP.VertOffset +%BP.VertScale + 20)
  drawline @BioRitmo 14 3 %BP.HorzOffset $calc(%BP.VertOffset  - %BP.VertScale) $calc(%BP.HorzOffset + 10) $calc(%BP.VertOffset  - %BP.VertScale)
  drawline @BioRitmo 14 3 %BP.HorzOffset $calc(%BP.VertScale + %BP.VertOffset) $calc(%BP.HorzOffset + 10) $calc(%BP.VertScale + %BP.VertOffset)
  BioCurves
  BioScale
  BioText
  unset %BP.* %Bio.*
}

alias BioCurves {
  set %Bio.Pi 3.14159
  set %Bio.i 0
  :BioFunc
  if (%Bio.i >= 31 ) { goto BioFuncEnd }
  set %Bio.EmoFunc $calc(2 * %Bio.Pi * $calc(%Bio.i + %Bio.EmoFraction) / 28 + %Bio.Pi)
  set %Bio.PhyFunc $calc(2 * %Bio.Pi * $calc(%Bio.i + %Bio.PhyFraction) / 23 + %Bio.Pi ))
  set %Bio.IntFunc $calc(2 * %Bio.Pi * $calc(%Bio.i + %Bio.IntFraction) / 33 + %Bio.Pi ))
  drawdot @BioRitmo 3 1 $calc((%Bio.i * %BP.HorzScale) + %BP.HorzOffset) $calc(($sin(%Bio.EmoFunc) * %BP.VertScale) + %BP.VertOffset)
  drawdot @BioRitmo 12 1 $calc((%Bio.i * %BP.HorzScale + %BP.HorzOffset)) $calc(($sin(%Bio.PhyFunc) * %BP.VertScale) + %BP.VertOffset)
  drawdot @BioRitmo 4 1 $calc((%Bio.i * %BP.HorzScale) + %BP.HorzOffset) $calc(($sin(%Bio.IntFunc) * %BP.VertScale) + %BP.VertOffset)
  inc %Bio.i .02 | goto BioFunc
  :BioFuncEnd
}

alias BioText {
  drawtext -c @BioRitmo 14 fixedsys 10 $calc(%BP.HorzOffset ) $calc(%BP.VertOffset - %BP.VertScale - 40) 250 16 Eje izqu. = Hoy $adate 
  drawtext -c @BioRitmo 14 fixedsys 10 $calc(%BP.HorzMax - 150 ) $calc(%BP.VertOffset - %BP.VertScale - 40) 250 16 Dias vividos: %Bio.DaysLived 
  drawtext -c @BioRitmo 14 fixedsys 10 $calc(%BP.HorzOffset + 5) $calc(%BP.VertScale + %BP.VertOffset + 10) 150 16 Min
  drawtext -c  @BioRitmo 14 fixedsys 10 $calc(%BP.HorzOffset + 5) $calc(%BP.VertOffset - %BP.VertScale - 20) 150 16 Max
  drawtext  -bc @BioRitmo 1 3 fixedsys 10 $calc(%BP.HorzOffset + 80) $calc((%BP.VertScale * 2) + %BP.VertOffset - 50) 150 16 Emocional
  drawtext  -bc @BioRitmo 1 12 fixedsys 10 $calc(%BP.HorzOffset + 200) $calc((%BP.VertScale * 2) + %BP.VertOffset - 50) 150 16 Fisico
  drawtext  -bc @BioRitmo 1 4 fixedsys 10 $calc(%BP.HorzOffset + 300) $calc((%BP.VertScale * 2) + %BP.VertOffset - 50) 150 16 Intelectual
}

alias BioScale {
  set %Bio.x 0
  :Bioxaxis
  if ( %Bio.x >= 32 ) { goto Bioxaxisend }
  if ($BioDayofWk(%Bio.TodayJ) == Sa) { %Bio.Linecol = 7 }
  elseif ($BioDayofWk(%Bio.TodayJ) == Do) { %Bio.Linecol = 13 }
  else %Bio.Linecol = 14
  drawline @BioRitmo %Bio.Linecol 0 $calc((%BP.HorzScale * %Bio.x) + %BP.HorzOffset) $calc(%BP.VertOffset - %BP.VertScale - 20)  $calc((%BP.HorzScale * %Bio.x) + %BP.HorzOffset) $calc(%BP.VertOffset +%BP.VertScale + 20)
  drawtext -c @BioRitmo 15 arial 12 $calc((%BP.HorzScale * %Bio.x) + %BP.HorzOffset + 2) $calc(%BP.VertOffset + 15) 150 14 $BioDayofWk(%Bio.TodayJ)
  drawtext -c @BioRitmo 15 arial 12 $calc((%BP.HorzScale * %Bio.x) + %BP.HorzOffset + 2) $calc(%BP.VertOffset + 5) 150 14 $gettok($BioJulian2dat(%Bio.TodayJ),2,32)
  inc %Bio.x | inc %Bio.TodayJ | goto Bioxaxis
  :Bioxaxisend
}
